## @package feynmanRules
# Here, we provide the class modules.feynmanRules.FeynmanRules which can be generated by modules.feynmanRulesReader.FeynmanRulesReader
# and contains information about Feynman rules. Future iterations will provide functions returning the appropriate code. (TODO: move from diaGenerator and provide a backend-independent representation)

import re
import logging

## The FeynmanRules class contains the Feynman rules.
#
class FeynmanRules:
    ## The constructor, initializes all members.
    #  @param self The object pointer.
    #  @param conf A modules.config.Conf object. Has to contain paths to .prop and .vrtx files. Otherwise an error occurs.
    def __init__(self, conf):
        ## modules.config.Config object
        self.conf = conf
        ## Dict containing the code template for the Lorentz part of each propagator Feynman rule as specified in the prop file.
        # The key is a sorted tuple of particle names of the interaction for which the given Feynman rule is defined.
        # The values are lists of entries which shall be inserted for the Lorentz fold. Multiple list members mean multiple Feynman rules with the same particle content and are duplicated in (e)dia generation.
        # Eg. {("g","g"): ["*Dg1(<lorentz_index_vertex_1>,<lorentz_index_vertex_2>,<momentum>)", "*Dg2(<lorentz_index_vertex_1>,<lorentz_index_vertex_2>,<momentum>)"]}
        self.propLorentz = {}
        ## Dict containing the code template for the SU(3) colour part of each propagator Feynman rule as specified in the prop file.
        # The key is a sorted tuple of particle names of the interaction for which the given Feynman rule is defined.
        # The values are lists of entries which shall be inserted for the QCD fold. Multiple list members mean multiple Feynman rules with the same particle content and are duplicated in (e)dia generation.
        # Eg. {("g","g"): ["*prop1(<colour_index_vertex_1>,<colour_index_vertex_2>)", "*prop2(<colour_index_vertex_1>,<colour_index_vertex_2>)"]}
        self.propQCD = {}
        ## Dict containing the code template for the EW part of each propagator Feynman rule as specified in the prop file.
        # The key is a sorted tuple of particle names of the interaction for which the given Feynman rule is defined.
        # The values are lists of entries which shall be inserted for the EW fold. Multiple list members mean multiple Feynman rules with the same particle content and are duplicated in (e)dia generation.
        # Eg. {("g","g"): ["", ""]}
        self.propEW = {}
        ## Dict containing the code template for the QED part of each propagator Feynman rule as specified in the prop file.
        # The key is a sorted tuple of particle names of the interaction for which the given Feynman rule is defined.
        # The values are lists of entries which shall be inserted for the QED fold. Multiple list members mean multiple Feynman rules with the same particle content and are duplicated in (e)dia generation.
        # Eg. {("g","g"): ["", ""]}
        self.propQED = {}
        ## Dict containing the code template for the Lorentz part of each propagator Feynman rule as specified in the vrtx file.
        # The key is a sorted tuple of particle names of the interaction for which the given Feynman rule is defined.
        # The values are lists of entries which shall be inserted for the Lorentz fold. Multiple list members mean multiple Feynman rules with the same particle content and are duplicated in (e)dia generation.
        # Eg. {("fq", "fQ","g"): ["*qqgVertexL1", "*qqgVertexL2"]}
        self.vrtxLorentz = {}
        ## Dict containing the code template for the SU(3) colour part of each propagator Feynman rule as specified in the vrtx file.
        # The key is a sorted tuple of particle names of the interaction for which the given Feynman rule is defined.
        # The values are lists of entries which shall be inserted for the QCD fold. Multiple list members mean multiple Feynman rules with the same particle content and are duplicated in (e)dia generation.
        # Eg. {("fq", "fQ","g"): ["*qqgVertexQCD1", "*qqgVertexQCD2"]}
        self.vrtxQCD = {}
        ## Dict containing the code template for the EW part of each propagator Feynman rule as specified in the vrtx file.
        # The key is a sorted tuple of particle names of the interaction for which the given Feynman rule is defined.
        # The values are lists of entries which shall be inserted for the EW fold. Multiple list members mean multiple Feynman rules with the same particle content and are duplicated in (e)dia generation.
        # Eg. {("fq", "fQ","g"): ["", ""]}
        self.vrtxEW = {}
        ## Dict containing the code template for the QED part of each propagator Feynman rule as specified in the vrtx file.
        # The key is a sorted tuple of particle names of the interaction for which the given Feynman rule is defined.
        # The values are lists of entries which shall be inserted for the QED fold. Multiple list members mean multiple Feynman rules with the same particle content and are duplicated in (e)dia generation.
        # Eg. {("fq", "fQ","g"): ["", ""]}
        self.vrtxQED = {}
        ## Dict containing transversal and longitudinal parts of gauge boson fields (used by the UFOReader module)
        self.gaugeProps = {}


    ## This method matches a modules.diagram.Line object onto one or more Feynman rules.
    #  @param self The object pointer.
    #  @param line A modules.diagram.Line object
    #  \return List of `(key, value)`` tuples with the `key` representing the particle content (as in #propLorentz etc.) and the `value` the index of of which rule was meant if multiple rules arise.
    #   E.g. `[(("fq","fQ"),0), (("fq","fQ"),1), (("fQ","fq"),0)]` if there are three Feynman rules which describe the propagation of `fq`.
    def getPropRuleKeys(self,line):
        toMatch = [line.incomingParticle,line.outgoingParticle]
        matchedPropList = []

        # Loop over all propagator Feynman rules and collect the ones with matching particle content
        for rule in self.propLorentz.keys():
            if (len(rule) == len(toMatch)) and (sorted(rule) == sorted(toMatch)):
                for i in range(len(self.propLorentz[rule])):
                    matchedPropList.append((rule, i))

        return matchedPropList


    ## This matches a modules.diagram.Vertex object onto one ore more Feynman rules.
    #  @param self The object pointer.
    #  @param vertex A modules.diagram.Vertex object
    #  \return List of `(key, value)`` tuples with the `key` representing the particle content (as in #propLorentz etc.) and the `value` the index of of which rule was meant if multiple rules arise.
    #   E.g. `[(("fQ","fq","g"),0), (("fQ","fq","g"),1), (("fQ","g","fq"),0)]` if there are three Feynman rules which describe a fq-fQ-g interaction.
    def getVertexRuleKeys(self,vertex):
        toMatch = vertex.getOutgoingParticles()
        matchedVrtxList = []

        # Loop over all propagator Feynman rules and collect the ones with matching particle content
        for rule in self.vrtxLorentz.keys():
            if (len(rule) == len(toMatch)) and (sorted(rule) == sorted(toMatch)):
                for i in range(len(self.vrtxLorentz[rule])):
                    matchedVrtxList.append((rule, i))

        return matchedVrtxList


    ## This matches a modules.diagram.Line object onto a Feynman rule.
    #  @param self The object pointer.
    #  @param line A modules.diagram.Line object
    #  @param numLegs Number of legs of the diagram, NOT of the vertex.
    #  @param propRuleKey (particleNamesTuple, ruleIndex) key from #getPropRuleKeys() for the current propagator
    #  \return A list containing the momentum and index of each of the vertex legs.
    #
    #  If the propagator is fermionic and flipped, i.e. the first particle is not an anti-fermion, we have to add a minus sign.
    #  The output takes the form <code>ret = ["g,g","p1",1,2]</code> If no rule matches the output is an empty list.
    def matchPropByRuleKey(self,line,numLegs,propRuleKey):
        toMatch = [line.incomingParticle,line.outgoingParticle]
        # Get the momenta of the matched vertex
        ret = self.match(propRuleKey[0], toMatch)

        # Compute indices
        if line.momentum[0] != "-":
            indices = [2*(int(line.momentum[1::])+numLegs-1)+1,2*(int(line.momentum[1::])+numLegs-1)+2]
        else:
            indices = [2*(int(line.momentum[2::])+numLegs-1)+1,2*(int(line.momentum[2::])+numLegs-1)+2]

        # Test if line is flipped and add a minus sign, this implementation does not depend on the
        # implementation of modules.diagram.fermionLine.isFlipped , which will be useful
        # for an implementation of fermionic indices.
        if line.fermionLine == True and indices[ret[0]] < indices[ret[1]]:
            mom = "-"+line.momentum
            # (-1)*(-1) = 1
            if mom[0] == mom[1]:
                mom = mom[2::]
            return [",".join(propRuleKey[0]),mom,indices[ret[1]],indices[ret[0]]]
        else:
            return [",".join(propRuleKey[0]),line.momentum,indices[ret[0]],indices[ret[1]]]


    ## This matches a modules.diagram.Vertex object onto a Feynman rule.
    #  @param self The object pointer.
    #  @param vertex A modules.diagram.Vertex object
    #  @param numLegs Number of legs of the diagram, NOT of the vertex.
    #  @param vrtxRuleKey (particleNamesTuple, ruleIndex) key from #getVrtxRuleKeys() for the current vertex
    #  \return A list containing the momentum and index of each of the vertex legs.
    #
    #  It is important that currently we are only supporting Feynman rules where all particles are outgoing.
    #  The output takes the form <code>ret = ["g,g,h,...",[p1,1],[p2,2],[p3,3],...]</code>. If no rule matches the output is an empty list.
    def matchVertexByRuleKey(self,vertex,numLegs,vertexRuleKey):
        toMatch = vertex.getOutgoingParticles()
        momenta = vertex.getOutgoingMomenta()
        indices = vertex.getIndices(numLegs)

        match = self.match(vertexRuleKey[0],toMatch)
        ret = [",".join(vertexRuleKey[0])]
        for i in match:
            ret += [momenta[i],indices[i],toMatch[i]]
        return ret


    ## This routine checks if two lists only differ by the ordering and returns a mapping.
    #  @param self The object pointer.
    #  @param l1 List to be matched onto \p l2.
    #  @param l2 Reference list.
    #  \return The positions of the elements of \p l1 in \p l2, if the lists are equal, otherwise an empty list.
    #
    #  This routine is a helper for #matchVertex . If \p l1 contains the same elements as \p l2
    #  it determines which position in \p l2 corresponds to the respective element of \p l1.
    #  For example if <code>l1 = [fq,fQ,g]</code> and <code>l2 = [g,fq,fQ]</code> the output is <code>ret = [2,3,1]</code>.
    #  Having multiple particles with the same name is supported e.g. for
    #  <code>l1 = [g,h,g,g,h,g]</code> and <code>l2 = [g,g,g,g,h,h]</code> the output is <code>ret = [1,5,2,3,6,4]</code>
    def match(self,l1,l2):
        # Are the two lists of the same length?
        if len(l1) != len(l2):
            return []
        # If yes, do they contain the same elements?
        elif sorted(l1) != sorted(l2):
            return []
        # Now we know that only the ordering can be different
        else:
            ret = []
            # Loop over all elements of l1.
            for p in l1:
                # Loop over all elements of l2.
                for i in range(0,len(l2)):
                    # If p matches on an element of l2 and this element is no in ret already, append it and continue with the next p.
                    if p == l2[i] and i not in ret:
                        ret.append(i)
                        break

            return ret


    ## Get particle mass according to #config.mass with anti-particles according to propagators taken into account
    # If the particle or a propagator sharing particle of #propList has a specified mass in #config.mass, return it.
    # @param particleName Name of the particle whose mass we want
    # @return Mass of the particle as a string. Massless particles get a "0" mass.
    def getParticleMass(self, particleName):
        # Particle in config.mass
        if particleName in self.conf.mass:
            return self.conf.mass[particleName]

        # Anti-particle in conf.mass
        for props in self.propLorentz.keys():
            if particleName == props[0] and props[1] in self.conf.mass:
                return self.conf.mass[props[1]]
            elif particleName == props[1] and props[0] in self.conf.mass:
                return self.conf.mass[props[0]]

        # Particle is massless
        return "0"


    ## This routine returns the FORM code for a vertex Feynman rule.
    #  @param self The object pointer.
    #  @param match The match for the vertex. Return value of #matchVertexByRuleKey()
    #  @param vrtxRuleKey (particleNamesTuple, ruleIndex) key from #getVrtxRuleKeys() which gives key and index of #vrtxQCD, #vrtxQED, #vrtxEW, or #vrtxLorentz that corresponds to the matched vertex
    #  @param fold Name of the fold.
    #  @param vertexnum Number of the vertex.
    #  @param numextmom Number of external momenta.
    #  @param fermion Indicator if we are dealing with a q2e-style fermion line or not.
    #  @param fermionum Number of the fermion line. 0 by default. Optional.
    #  \return String containing the code.
    def returnFORMStringVrtx(self, match, vrtxRuleKey, fold, vertexnum, numextmom, fermion, fermionnum=0):
        feynVrtx = ""
        lineBreak = ""
        if fold == "QCD":
            feynVrtx = self.vrtxQCD
            lineBreak = "\n\t"
        elif fold == "QED":
            feynVrtx = self.vrtxQED
            lineBreak = ""
        elif fold == "EW":
            feynVrtx = self.vrtxEW
            lineBreak = ""
        elif fold == "DIA":
            feynVrtx = self.vrtxLorentz
            lineBreak = "\n\t"

        if feynVrtx[vrtxRuleKey[0]][vrtxRuleKey[1]] == "":
            return ""

        tmpString = feynVrtx[vrtxRuleKey[0]][vrtxRuleKey[1]] + lineBreak
        l = len(match[0].split(","))
        # Now substitute the indices and momenta in the template
        for i in range(0,l):
            # spin lines are only available without spinor indices
            if not self.conf.spinorIndices and fermion:
                tmpString = tmpString.replace("<spin_line>",str(fermionnum))
            else:
                if "<spin_line>" in tmpString:
                    logging.error("spin_line found but in spinor index mode. Try option `tapir.contract_fermion_lines`")
                    exit(1)
            # extract all possible antiParticles to find the right mass
            tmpString = tmpString.replace("<mass_particle_" + str(i+1) + ">", self.getParticleMass(match[3+3*i]))
            tmpString = tmpString.replace("<add_index_1_particle_" + str(i+1) + ">","al" + str(match[2+3*i]))
            tmpString = tmpString.replace("<add_index_2_particle_" + str(i+1) + ">","be" + str(match[2+3*i]))
            tmpString = re.sub(r'<local_index_([a-zA-Z0-9]+)>', r'\g<1>' + str(vertexnum), tmpString)
            tmpString = tmpString.replace("<spinor_index_particle_-1>", "iufo" + str(match[2+3*i]))
            # Insert the correct gauge parameter
            for gauge in self.conf.gaugeDict:
                tmpString = tmpString.replace("<gauge_parameter_xi" + str(gauge) + ">", str(self.conf.gaugeDict[gauge]))

            # External legs
            if "q" in match[1+3*i]:
                if self.conf.expCompat == True:
                    tmpString = tmpString.replace("<outgoing_momentum_" + str(i+1) + ">", "L,-1," + match[1+3*i] + ",-1,L")
                else:
                    tmpString = tmpString.replace("<outgoing_momentum_" + str(i+1) + ">", match[1+3*i])
                tmpString = tmpString.replace("<lorentz_index_particle_" + str(i+1) + ">", "mu" + str(match[2+3*i]))
                tmpString = re.sub(r'<lorentz_index_([0-9]+)_particle_' + str(i+1) + ">", r'mu'+str(match[2+3*i])+r'n\1', tmpString)
                tmpString = tmpString.replace("<colour_index_particle_" + str(i+1) + ">", "a(" + str(match[2+3*i]) + ")")
                tmpString = tmpString.replace("<colour_index_particle_-1>", "aufo(" + str(match[2+3*i]) + ")")
                tmpString = tmpString.replace("<spinor_index_particle_" + str(i+1) + ">", "i" + str(match[2+3*i]))
                tmpString = tmpString.replace("<fundamental_index_particle_" + str(i+1) + ">", "fe" + str(match[2+3*i]))
                tmpString = re.sub(r'<fundamental_index_([0-9]+)_particle_' + str(i+1) + ">", r'fe'+str(match[2+3*i])+r'n\1', tmpString)
                # Eliminate last of the external momenta
                tmpString = tmpString.replace("-1,q" + str(numextmom) +",-1","-1,-" +
                    ",-".join(["q" + str(i) for i in range(1,numextmom)]) + ",-1")
                tmpString = tmpString.replace("-1,-q" + str(numextmom) +",-1","-1," +
                    ",".join(["q" + str(i) for i in range(1,numextmom)]) + ",-1")

                if not fermion:
                    if match[3+3*i] in self.conf.closedFermionLoop:
                        tmpString = tmpString.replace("<flavour_particle_" + str(i+1) + ">", self.conf.closedFermionLoop[match[3+3*i]])
                    else:
                        tmpString = tmpString.replace("<flavour_particle_" + str(i+1) + ">","1")

            # Internal legs
            else:
                tmpString = tmpString.replace("<outgoing_momentum_" + str(i+1) + ">", match[1+3*i])
                tmpString = tmpString.replace("<lorentz_index_particle_" + str(i+1) + ">", "nu" + str(match[2+3*i]))
                tmpString = re.sub(r'<lorentz_index_([0-9]+)_particle_' + str(i+1) + ">", r'nu'+str(match[2+3*i])+r'n\1', tmpString)
                tmpString = tmpString.replace("<colour_index_particle_" + str(i+1) + ">", "b(" + str(match[2+3*i]) + ")")
                tmpString = tmpString.replace("<colour_index_particle_-1>", "bufo(" + str(match[2+3*i]) + ")")
                tmpString = tmpString.replace("<spinor_index_particle_" + str(i+1) + ">", "j" + str(match[2+3*i]))
                tmpString = tmpString.replace("<spinor_index_particle_-1>", "iufo" + str(match[2+3*i]))
                tmpString = tmpString.replace("<fundamental_index_particle_" + str(i+1) + ">", "fi" + str(match[2+3*i]))
                tmpString = re.sub(r'<fundamental_index_([0-9]+)_particle_' + str(i+1) + ">", r'fi'+str(match[2+3*i])+r'n\1', tmpString)

                if not fermion:
                    if match[3+3*i] in self.conf.closedFermionLoop:
                        tmpString = tmpString.replace("<flavour_particle_" + str(i+1) + ">", self.conf.closedFermionLoop[match[3+3*i]])
                    else:
                        tmpString = tmpString.replace("<flavour_particle_" + str(i+1) + ">","1")

        return tmpString


    ## This routine returns the FORM code for a propagator Feynman rule.
    #  @param self The object pointer.
    #  @param match The match for the propagator. Return value of #matchPropByRuleKey()
    #  @param propRuleKey (particleNamesTuple, ruleIndex) key from #getPropRuleKeys() which gives key and index of #propQCD, #propQED, #propEW, or #propLorentz that corresponds to the matched vertex
    #  @param fold Name of the fold.
    #  @param linenum Number of the propagator.
    #  @param inparticle Type of incoming particle
    #  @parem outparticle Type of outgoing particle
    #  @param fermion Indicator if we are dealing with a q2e-style fermion line or not.
    #  @param fermionum Number of the fermion line. 0 by default. Optional.
    #  \return String containing the code.
    def returnFORMStringProp(self, match, propRuleKey, fold, linenum, inparticle, outparticle, fermion, fermionnum=0):
        feynProp = ""
        lineBreak = ""
        if fold == "QCD":
            feynProp = self.propQCD
            lineBreak = "\n\t"
        elif fold == "QED":
            feynProp = self.propQED
            lineBreak = ""
        elif fold == "EW":
            feynProp = self.propEW
            lineBreak = ""
        elif fold == "DIA":
            feynProp = self.propLorentz
            lineBreak = "\n\t"

        if feynProp[propRuleKey[0]][propRuleKey[1]] == "":
            return ""

        tmpString = feynProp[propRuleKey[0]][propRuleKey[1]] + lineBreak
        # tmpString = feynProp[matchedPropRuleNumber] + lineBreak
        # spin lines are only available without spinor indices
        if not self.conf.spinorIndices and fermion:
            tmpString = tmpString.replace("<spin_line>",str(fermionnum))
        else:
            if "<spin_line>" in tmpString:
                logging.error("spin_line found but in spinor index mode. Try option `tapir.contract_fermion_lines`")
                exit(1)
        tmpString = tmpString.replace("<momentum>",match[1])
        tmpString = tmpString.replace("<mass>", self.getParticleMass(inparticle))
        tmpString = re.sub(r'<local_index_([a-zA-Z0-9]+)>', r'\g<1>' + str(linenum), tmpString)
        tmpString = tmpString.replace("<lorentz_index_vertex_1>","nu" + str(match[2]))
        tmpString = tmpString.replace("<lorentz_index_vertex_2>","nu" + str(match[3]))
        tmpString = tmpString.replace("<colour_index_vertex_1>","b(" + str(match[2]) + ")")
        tmpString = tmpString.replace("<colour_index_vertex_2>","b(" + str(match[3]) + ")")
        tmpString = tmpString.replace("<spinor_index_vertex_1>","j" + str(match[2]))
        tmpString = tmpString.replace("<spinor_index_vertex_2>","j" + str(match[3]))
        tmpString = tmpString.replace("<add_index_1_vertex_1>","al" + str(match[2]))
        tmpString = tmpString.replace("<add_index_1_vertex_2>","al" + str(match[3]))
        tmpString = tmpString.replace("<add_index_2_vertex_1>","be" + str(match[2]))
        tmpString = tmpString.replace("<add_index_2_vertex_2>","be" + str(match[3]))
        tmpString = re.sub(r'<lorentz_index_([0-9]+)_vertex_1>', r'nu'+str(match[2])+r'n\1', tmpString)
        tmpString = re.sub(r'<lorentz_index_([0-9]+)_vertex_2>', r'nu'+str(match[3])+r'n\1', tmpString)
        tmpString = tmpString.replace("<fundamental_index_vertex_1>","fi" + str(match[2]))
        tmpString = tmpString.replace("<fundamental_index_vertex_2>","fi" + str(match[3]))
        tmpString = re.sub(r'<fundamental_index_([0-9]+)_vertex_1>', r'fi'+str(match[2])+r'n\1', tmpString)
        tmpString = re.sub(r'<fundamental_index_([0-9]+)_vertex_2>', r'fi'+str(match[3])+r'n\1', tmpString)
	# Insert the correct gauge parameter
        for gauge in self.conf.gaugeDict:
            tmpString = tmpString.replace("<gauge_parameter_xi" + str(gauge) + ">", str(self.conf.gaugeDict[gauge]))
	# Replace the mass in the longitudinal gauge boson propagators by the corresponding transversal one
        for longField in self.gaugeProps:
            if self.conf.gaugeProps[longField] in self.conf.mass:
                tmpString = tmpString.replace("<physical_mass_" + str(self.conf.gaugeProps[longField]) + ">", str(self.conf.mass[self.conf.gaugeProps[longField]]))
            else:
                logging.warning("Longitudinal gauge boson propagator for massless gauge boson: " + str(longField))
        if not fermion:
            if inparticle in self.conf.closedFermionLoop:
                tmpString = tmpString.replace("<flavour_vertex_1>",self.conf.closedFermionLoop[inparticle])
            else:
                tmpString = tmpString.replace("<flavour_vertex_1>","1")
            if outparticle in self.conf.closedFermionLoop:
                tmpString = tmpString.replace("<flavour_vertex_2>",self.conf.closedFermionLoop[outparticle])
            else:
                tmpString = tmpString.replace("<flavour_vertex_2>","1")
        return tmpString



    # Routine for writing the vertex and propagator strings to separate files
    #  @param self      object pointer
    def writeq2eFiles(self):
        # write propagator strings to a .prop file
        fNameProp = self.conf.ufo_outdir + 'UFO.prop'
        with open(fNameProp, 'w') as propFile:
            for p in self.propLorentz.keys():
                try:
                    for i in range(len(self.propLorentz[p])):
                        outString = '{' + self.__extractParticlesFromTuple(p) + ':' + \
                            self.propLorentz[p][i] + '|\n\t\t' \
                            + self.propQCD[p][i] + '|' + self.propEW[p][i] \
                            + '|' + self.propQED[p][i] + '}\n\n'
                        propFile.write(outString)
                except:
                    logging.warning(' {} could not be processed'.format(p))

        fNameVrtx = self.conf.ufo_outdir + 'UFO.vrtx'
        with open(fNameVrtx, 'w') as vrtxFile:
            for v in self.vrtxLorentz.keys():
                try:
                    for i in range(len(self.vrtxLorentz[v])):
                        outString = '{' + self.__extractParticlesFromTuple(v) + ':' + \
                            self.vrtxLorentz[v][i] + '|\n\t\t' \
                            + self.vrtxQCD[v][i] + '|' + self.vrtxEW[v][i] \
                            + '|' + self.vrtxQED[v][i] + '}\n\n'
                        vrtxFile.write(outString)
                except:
                    logging.warning(' {} could not be processed'.format(v))


    # This concatenates the string objects of a tuple to one single string
    #  @param self      object pointer
    #  @param tup       tuple of strings
    #  @return          the concatenated string
    #
    #  e.g. ('fe','fE','WTp') -> 'fe,fE,WTp'
    def __extractParticlesFromTuple(self, tup):
        separator = ','
        retString = separator.join(tup)
        return retString

